"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SearcResultRecordEnum = exports.RecordView = exports.RecordPlayer = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const Commands = {
  init: 'init',
  startPlayRecord: 'startPlayRecord',
  searchRecordByFile: 'searchRecordByFile',
  capture: 'capture',
  startRecord: 'startRecord',
  stopRecord: 'stopRecord',
  isRecording: 'isRecording',
  openVoice: 'openVoice',
  closeVoice: 'closeVoice',
  pausePlay: 'pausePlay',
  rePlay: 'rePlay',
  stopPlay: 'stopPlay',
  destroyPlay: 'destroyPlay',
  isRecordPlay: 'isRecordPlay',
  downloadFile: 'downloadFile',
  setPlaySpeed: 'setPlaySpeed',
  startPlayRecordByTime: 'startPlayRecordByTime'
};
const dispatchCommand = function (viewId, command) {
  let args = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  _reactNative.UIManager.dispatchViewManagerCommand(viewId, _reactNative.UIManager.getViewManagerConfig('RCTDevRecordMonitor').Commands[command] || '', args);
};
let SearcResultRecordEnum = /*#__PURE__*/function (SearcResultRecordEnum) {
  SearcResultRecordEnum["RECORD_FILES"] = "recordfiles";
  SearcResultRecordEnum["RECORD_TIMELIST"] = "recordtimelist";
  return SearcResultRecordEnum;
}({});
exports.SearcResultRecordEnum = SearcResultRecordEnum;
const RecordView = (0, _reactNative.requireNativeComponent)('RCTDevRecordMonitor');
exports.RecordView = RecordView;
const RecordPlayer = /*#__PURE__*/(0, _react.forwardRef)((_ref, ref) => {
  let {
    onMediaPlayState,
    onShowRateAndTime,
    onVideoBufferEnd,
    onSearchRecordByFilesResult,
    // onSearchRecordByTimesResult,
    onFailed,
    onStartInit,
    onDebugState,
    onDownloadProgress,
    onDownloadState,
    ...props
  } = _ref;
  const viewRef = (0, _react.useRef)(null);
  const _onMediaPlayState = event => {
    onMediaPlayState && onMediaPlayState(event.nativeEvent);
  };
  const _onShowRateAndTime = event => {
    onShowRateAndTime && onShowRateAndTime(event.nativeEvent);
  };
  const _onVideoBufferEnd = event => {
    onVideoBufferEnd && onVideoBufferEnd(event.nativeEvent);
  };
  const _onSearchRecordByFilesResult = event => {
    onSearchRecordByFilesResult && onSearchRecordByFilesResult(event.nativeEvent);
  };

  // const _onSearchRecordByTimesResult = (event: any) => {
  //   onSearchRecordByTimesResult &&
  //     onSearchRecordByTimesResult(event.nativeEvent);
  // };

  const _onStartInit = () => {
    onStartInit && onStartInit();
  };
  const _onFailed = event => {
    onFailed && onFailed(event.nativeEvent);
  };
  const _onDebugState = event => {
    onDebugState && onDebugState(event.nativeEvent);
  };
  const _onDownloadProgress = event => {
    onDownloadProgress && onDownloadProgress(event.nativeEvent);
  };
  const _onDownloadState = event => {
    onDownloadState && onDownloadState(event.nativeEvent);
  };
  (0, _react.useImperativeHandle)(ref, () => {
    return {
      init() {
        // console.log('initing');
        const viewId = (0, _reactNative.findNodeHandle)(viewRef.current);
        if (typeof viewId !== 'number') {
          return;
        }
        dispatchCommand(viewId, Commands.init, []);
      },
      startPlayRecord(position) {
        const viewId = (0, _reactNative.findNodeHandle)(viewRef.current);
        if (typeof viewId !== 'number') {
          return;
        }
        dispatchCommand(viewId, Commands.startPlayRecord, [position]);
      },
      startPlayRecordByTime(startTimestamp, endTimestamp) {
        const viewId = (0, _reactNative.findNodeHandle)(viewRef.current);
        if (typeof viewId !== 'number') {
          return;
        }
        dispatchCommand(viewId, Commands.startPlayRecordByTime, [startTimestamp, endTimestamp]);
      },
      searchRecordByFile(startTimestamp, endTimestamp) {
        const viewId = (0, _reactNative.findNodeHandle)(viewRef.current);
        if (typeof viewId !== 'number') {
          return;
        }
        dispatchCommand(viewId, Commands.searchRecordByFile, [startTimestamp, endTimestamp]);
      },
      capture(path) {
        const viewId = (0, _reactNative.findNodeHandle)(viewRef.current);
        if (typeof viewId !== 'number') {
          return;
        }
        dispatchCommand(viewId, Commands.capture, [path]);
      },
      startRecord(path) {
        const viewId = (0, _reactNative.findNodeHandle)(viewRef.current);
        if (typeof viewId !== 'number') {
          return;
        }
        dispatchCommand(viewId, Commands.startRecord, [path]);
      },
      stopRecord() {
        const viewId = (0, _reactNative.findNodeHandle)(viewRef.current);
        if (typeof viewId !== 'number') {
          return;
        }
        dispatchCommand(viewId, Commands.stopRecord, []);
      },
      isRecording() {
        const viewId = (0, _reactNative.findNodeHandle)(viewRef.current);
        if (typeof viewId !== 'number') {
          return;
        }
        dispatchCommand(viewId, Commands.isRecording, []);
      },
      openVoice() {
        const viewId = (0, _reactNative.findNodeHandle)(viewRef.current);
        if (typeof viewId !== 'number') {
          return;
        }
        dispatchCommand(viewId, Commands.openVoice, []);
      },
      closeVoice() {
        const viewId = (0, _reactNative.findNodeHandle)(viewRef.current);
        if (typeof viewId !== 'number') {
          return;
        }
        dispatchCommand(viewId, Commands.closeVoice, []);
      },
      pausePlay() {
        const viewId = (0, _reactNative.findNodeHandle)(viewRef.current);
        if (typeof viewId !== 'number') {
          return;
        }
        dispatchCommand(viewId, Commands.pausePlay, []);
      },
      rePlay() {
        const viewId = (0, _reactNative.findNodeHandle)(viewRef.current);
        if (typeof viewId !== 'number') {
          return;
        }
        dispatchCommand(viewId, Commands.rePlay, []);
      },
      stopPlay() {
        const viewId = (0, _reactNative.findNodeHandle)(viewRef.current);
        if (typeof viewId !== 'number') {
          return;
        }
        dispatchCommand(viewId, Commands.stopPlay, []);
      },
      destroyPlay() {
        const viewId = (0, _reactNative.findNodeHandle)(viewRef.current);
        if (typeof viewId !== 'number') {
          return;
        }
        dispatchCommand(viewId, Commands.destroyPlay, []);
      },
      isRecordPlay() {
        const viewId = (0, _reactNative.findNodeHandle)(viewRef.current);
        if (typeof viewId !== 'number') {
          return;
        }
        dispatchCommand(viewId, Commands.isRecordPlay, []);
      },
      downloadFile(position, path) {
        const viewId = (0, _reactNative.findNodeHandle)(viewRef.current);
        if (typeof viewId !== 'number') {
          return;
        }
        dispatchCommand(viewId, Commands.downloadFile, [position, path]);
      },
      /**
       * Устанавливает скорость воспроизведения для видео или аудио.
       *
       * @param {number} playSpeed - Скорость воспроизведения. Может быть одним из следующих значений:
       *   -3, -2, -1, 0, 1, 2, 3
       * @returns {void}
       */
      setPlaySpeed(playSpeed) {
        const viewId = (0, _reactNative.findNodeHandle)(viewRef.current);
        if (typeof viewId !== 'number') {
          return;
        }
        dispatchCommand(viewId, Commands.setPlaySpeed, [playSpeed]);
      }
    };
  }, []);
  return /*#__PURE__*/_react.default.createElement(RecordView
  // onLayout={(event) => console.log('event: ', event.nativeEvent.layout)}
  , _extends({
    ref: viewRef
  }, props, {
    onMediaPlayState: _onMediaPlayState,
    onShowRateAndTime: _onShowRateAndTime,
    onVideoBufferEnd: _onVideoBufferEnd,
    onSearchRecordByFilesResult: _onSearchRecordByFilesResult
    // onSearchRecordByTimesResult={_onSearchRecordByTimesResult}
    ,
    onFailed: _onFailed,
    onStartInit: _onStartInit,
    onDebugState: _onDebugState,
    onDownloadProgress: _onDownloadProgress,
    onDownloadState: _onDownloadState
  }));
});
exports.RecordPlayer = RecordPlayer;
//# sourceMappingURL=index.js.map