import type { DeviceIdParams, DeviceManagerPromiseSuccessType, EFUN_ATTR } from './types';
type IsDeviceFunctionSupportParams = {
    deviceId: string;
    functionName: string;
    functionCommandStr: string;
};
export declare function isDeviceFunctionSupport(params: IsDeviceFunctionSupportParams): Promise<DeviceManagerPromiseSuccessType & {
    value: boolean;
}>;
export declare function getDeviceModel(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function getSoftWareVersion(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function getBuildTime(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function getHardWare(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType & {
    value: string;
}>;
export declare function getDigChannel(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType & {
    value: number;
}>;
export declare function getExtraChannel(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function getVideoInChannel(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function getTalkInChannel(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function getAlarmInChannel(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function getAlarmOutChannel(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function getCombineSwitch(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function getVideoOutChannel(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function getAudioInChannel(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function getTalkOutChannel(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function getUpdataTime(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function getEncryptVersion(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function getDeviceRunTime(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function getHardWareVersion(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function getMcuVersion(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare enum networkMode {
    P2P = 0,
    FORWARDING = 1,
    IP = 2,
    RPS = 5,
    RTS_P2P = 6,
    RTS = 7
}
export declare function getNetworkMode(params: DeviceIdParams): Promise<{
    value: networkMode;
}>;
export declare function getAccessToken(): Promise<string>;
export type SecretPromiseSuccessType = {
    timeMillis: string;
    secret: string;
    uuid: string;
    appKey: string;
    appSecret: string;
    movedCard: number;
};
export declare function getSecret(): Promise<SecretPromiseSuccessType>;
export declare function getFunStrAttr(params: {
    FunStrAttr: EFUN_ATTR;
}): Promise<string>;
export declare function devGetLocalUserName(params: DeviceIdParams): Promise<string>;
export declare function getDevType(params: DeviceIdParams): Promise<number>;
export declare function devGetLocalEncToken(params: DeviceIdParams): Promise<string>;
export {};
//# sourceMappingURL=info.d.ts.map