import type { DeviceCredentialParams, DeviceIdParams, DeviceInfoType, DeviceManagerPromiseSuccessType, EPTZCMD } from './types';
export declare function loginDevice(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export type LoginDeviceWithCredentialResponse = DeviceManagerPromiseSuccessType & {
    value: DeviceInfoType;
};
export declare function loginDeviceWithCredential(params: DeviceCredentialParams): Promise<LoginDeviceWithCredentialResponse>;
export declare function logoutDevice(params: DeviceIdParams): Promise<true>;
export declare function getChannelInfo(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType & {
    value: {
        canUsedChannelSize: number;
        isComOpen: boolean;
        nChnCount: number;
        st_channelTitle: string[];
    };
}>;
export declare function getChannelCount(params: DeviceIdParams): Promise<number>;
export type LocalLoginInfoParams = DeviceCredentialParams & {
    token: string;
};
export type ModifyDevicePasswordParams = DeviceCredentialParams & {
    deviceNewPassword: string;
};
export declare function modifyDevicePassword(params: ModifyDevicePasswordParams): Promise<DeviceManagerPromiseSuccessType>;
export type ModifyDeviceNameParams = DeviceIdParams & {
    deviceName: string;
};
export declare function modifyDeviceName(params: ModifyDeviceNameParams): Promise<DeviceManagerPromiseSuccessType>;
export type DevicePTZControlParams = {
    deviceId: string;
    command: EPTZCMD;
    bStop: boolean;
    deviceChannel: number;
    speed?: 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | number;
};
export declare function devicePTZcontrol(params: DevicePTZControlParams): Promise<boolean>;
export declare function resetDeviceConfig(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function rebootDevice(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export type CaptureFromDeviceAndSaveToDeviceParams = {
    deviceId: string;
    deviceChannel: number;
};
export declare function captureFromDeviceAndSaveToDevice(params: CaptureFromDeviceAndSaveToDeviceParams): Promise<DeviceManagerPromiseSuccessType>;
//# sourceMappingURL=manager.d.ts.map