export enum AlarmType {
  TYPE_LOCAL_ALARM = 'LocalAlarm', // Локальная тревога (фактический смысл зависит от устройства)
  TYPE_MOTION_DETECT = 'MotionDetect', // Обнаружение движения
  TYPE_VIDEO_MOTION = 'VideoMotion', // Обнаружение движения на видео
  TYPE_LOSS_DETECT = 'LossDetect', // Потеря видеосигнала
  TYPE_VIDEO_LOSS = 'VideoLoss', // Потеря видеосигнала
  TYPE_BLIND_DETECT = 'BlindDetect', // Видео скрыто
  TYPE_VIDEO_BLIND = 'VideoBlind', // Видео скрыто
  TYPE_IPC_ALARM = 'IPCAlarm', // Тревога IPC
  TYPE_LOCAL_IO = 'LocalIO', // Локальная ввод-выводная тревога (фактический смысл зависит от устройства)
  TYPE_STORAGE_WRITE_ERROR = 'StorageWriteError', // Ошибка записи на носитель
  TYPE_STORAGE_READ_ERROR = 'StorageReadError', // Ошибка чтения с носителя
  TYPE_STORAGE_FAILURE = 'StorageFailure', // Ошибка носителя
  TYPE_STORAGE_LOW_SPACE = 'StorageLowSpace', // Мало места на носителе
  TYPE_STORRAGE_LOW_SPACE = 'StorrageLowSpace', // Мало места на носителе
  TYPE_STORAGE_NOT_EXIST = 'StorageNotExist', // Носитель отсутствует
  TYPE_SERIAL_ALARM = 'SerialAlarm', // Серийная тревога
  TYPE_CONS_SENSOR_ALARM = 'ConsSensorAlarm', // Тревога датчика связи
  TYPE_HUMAN_DETECT = 'HumanDetect', // Обнаружено человекоподобное существо
  TYPE_FACE_DETECTION = 'FaceDetection', // Обнаружение лиц
  TYPE_FACE_DETECT = 'FaceDetect', // Обнаружение лиц
  TYPE_FACE_RECOGNITION = 'FaceRecognition', // Распознавание лиц
  TYPE_REMOTE_SNAP = 'RemoteSnap', // Удаленная съемка
  TYPE_NET_IP_CONFLICT = 'NetIPConflict', // Конфликт IP-адресов
  TYPE_SPEED_ALARM = 'SpeedAlarm', // Тревога скорости
  TYPE_GSENSOR_ALARM = 'GSensorAlarm', // Тревога G-сенсора
  TYPE_PIR_ALARM = 'PIRAlarm', // Тревога PIR
  TYPE_RECEIVED_CALL = 'TYPE_RECEIVED_CALL', // Принятый звонок
  TYPE_INTERVAL_WAKE = 'IntervalWakeAlarm', // Тревога пробуждения с интервалом
  TYPE_DOOR_LOCK_NOTIFY = 'DoorLockNotify', // Уведомление о замке двери
  TYPE_DOOR_LOCK_ALARM = 'DoorLockAlarm', // Тревога замка двери
  TYPE_DOOR_BELL = 'DoorLockCall', // Звонок замка двери
  TYPE_RESERVER_WAKE = 'ReserveWakeAlarm', // Резервное пробуждение
  TYPE_FORCE_DISMANTLE = 'ForceDismantleAlarm', // Принудительное демонтажное сообщение
  TYPE_LOW_BATTERY = 'LowBatteryAlarm', // Низкий заряд аккумулятора
  TYPE_VIDEO_ANALYZE = 'VideoAnalyze', // Видеоанализ
  TYPE_HUMANE = 'appEventHumanDetectAlarm', // Человекообразное существо
  TYPE_NOTICE_MSG = 'Door_Noice_Msg', // Уведомление о замке двери
  TYPE_EXCEPTION_MSG = 'Exception_Message', // Исключительное сообщение
  TYPE_REMOTE_CALL_ALARM = 'RemoteCallAlarm', // Тревога удаленного вызова
  TYPE_FEED_ERROR = 'FeedAlarm', // Ошибка кормления
  TYPE_FEED_LIMIT_ERROR = 'FeedLimitError', // Ошибка ограничения кормления
  MSG_TYPE_DOOR_BELL = 'DoorBell', // Звонок на дверь
  MSG_TYPE_PASS_WD = 'Passwd', // Проход по паролю
  MSG_TYPE_FINGER_PRINT = 'FingerPrint', // Проход по отпечатку пальца
  MSG_TYPE_CARD = 'Card', // Проход по карте
  MSG_TYPE_KEY = 'Key', // Проход по ключу
  MSG_TYPE_FINGER_PRINT_ERROR = 'FingerPrintError', // Ошибка ввода отпечатка пальца
  MSG_TYPE_PASS_WD_ERROR = 'PasswdError', // Ошибка ввода пароля
  MSG_TYPE_CARD_ERROR = 'CardError', // Ошибка ввода карты
  MSG_TYPE_FORCE_DEL_ALARM = 'ForceDelAlarm', // Принудительное удаление тревоги
  MSG_TYPE_TRESPASSING = 'Trespassing', // Незаконное вторжение
  MSG_TYPE_FORCE = 'Force', // Принуждение
  MSG_TYPE_STAY_AWAY = 'StayAlarm', // Оставание на месте
  MSG_TYPE_LOW_BATTERY = 'LowBattery', // Низкий уровень заряда батареи
  MSG_TYPE_DOOR_LOCK_OPEN_COUNT = 'DoorLockOpenCount', // Счетчик открытий замка двери
  MSG_TYPE_FACE = 'Face', // Проход по лицу
  MSG_TYPE_TRIAL_ERROR = 'TrialError', // Ошибка пробного прогона
  MSG_TYPE_DOOR_CLOSE = 'HasBeenClose', // Дверь закрыта
  MSG_TYPE_DOOR_OPEN = 'HasBeenOpen', // Дверь открыта
  MSG_TYPE_REMOTE = 'Remote', // Удаленный
}
